**"* use this source file for the definition and implementation of
**"* local helper classes, interface definitions and type
**"* declarations
*CLASS lsc_zmm_001_cls DEFINITION INHERITING FROM cl_abap_behavior_saver.
*  PROTECTED SECTION.
*    METHODS save_modified REDEFINITION.
*ENDCLASS.
*
*CLASS lsc_zmm_001_cls IMPLEMENTATION.
*
*  METHOD save_modified.
*    DATA : lt_jbkc TYPE STANDARD TABLE OF ztmm_001,
*           ls_jbkc TYPE                   ztmm_001.
**    IF zmm_001_cls=>cv_pr_mapped-purchaserequisition IS NOT INITIAL.
**      LOOP AT zmm_001_cls=>cv_pr_mapped-purchaserequisition ASSIGNING FIELD-SYMBOL(<fs_pr_mapped>).
**        CONVERT KEY OF i_purchaserequisitiontp FROM <fs_pr_mapped>-%pid TO DATA(ls_pr_key).
**        <fs_pr_mapped>-purchaserequisition = ls_pr_key-purchaserequisition.
**      ENDLOOP.
**    ENDIF.
**    select matnr
**           werks
**           lgort
**           labst
**           INTO CORRESPONDING FIELDS OF lt_jbkc
**           FROM mard
**           WHERE
*    IF create-online_shop IS NOT INITIAL.
*      " Creates internal table with instance data
*      lt_online_shop_as = CORRESPONDING #( create-online_shop ).
*      lt_online_shop_as[ 1 ]-purchasereqn =  ls_pr_key-purchaserequisition .
*
*      INSERT znick_shop_as FROM TABLE @lt_online_shop_as.
*    ENDIF.
*  ENDMETHOD.
*ENDCLASS.
*
*CLASS lhc_zmm_001_cls  DEFINITION INHERITING FROM cl_abap_behavior_handler.
*  PRIVATE SECTION.
*
*    METHODS get_instance_authorizations FOR INSTANCE AUTHORIZATION
*      IMPORTING keys REQUEST requested_authorizations FOR  online_shop RESULT result.
*
*    METHODS create_pr FOR MODIFY
*      IMPORTING keys FOR ACTION online_shop~create_pr.
*
*    METHODS update_inforecord FOR MODIFY
*      IMPORTING keys FOR ACTION online_shop~update_inforecord.
*
*    METHODS calculate_order_id FOR DETERMINE ON MODIFY
*      IMPORTING keys FOR online_shop~calculate_order_id.
*
*
*ENDCLASS.
*
*CLASS lhc_zmm_001_cls  IMPLEMENTATION.
*
*  METHOD get_instance_authorizations.
*  ENDMETHOD.
*
*  METHOD create_pr.
*
**  if a new package is ordered, trigger a new purchase requisition
*    DATA(key) = keys[ 1 ].
**      SELECT SINGLE * FROM ZC_PrePackagedItems WHERE Pkgid = @key-%param-PackageId INTO @DATA(ls_prepitem).
*
*    TRY.
**      MODIFY ENTITIES OF i_purchaserequisitiontp
**      ENTITY purchaserequisition
**      CREATE FIELDS ( purchaserequisitiontype )
**      WITH VALUE #(  ( %cid                    = 'My%CID_1'
**                       purchaserequisitiontype = 'NB' ) )
**      CREATE BY \_purchaserequisitionitem
**      FIELDS ( plant
**               purchaserequisitionitemtext
**               accountassignmentcategory
**               requestedquantity
**               baseunit
**               purchaserequisitionprice
**               purreqnitemcurrency
**               materialgroup
**               purchasinggroup
**               purchasingorganization )
**      WITH VALUE #( ( %cid_ref = 'My%CID_1'
**                      %target  = VALUE #( ( %cid                            = 'My%ItemCID_1'
**                                           plant                           = '1010'"ls_prepitem-Plant
**                                           purchaserequisitionitemtext     = 'Nick Test'"ls_prepitem-PurchaseRequisitionItemText
**                                           accountassignmentcategory       = ''"ls_prepitem-AccountAssignmentCategory
**                                           requestedquantity               = 500"ls_prepitem-RequestedQuantity
**                                           baseunit                        = 'KG'"ls_prepitem-BaseUnit
**                                           purchaserequisitionprice        = 200"ls_prepitem-PurchaseRequisitionPrice
**                                           purreqnitemcurrency             = 'CNY'"ls_prepitem-PurReqnItemCurrency
**                                           materialgroup                   = 'Z00101'"ls_prepitem-MaterialGroup
**                                           purchasinggroup                 = '001'"ls_prepitem-PurchasingGroup
**                                           purchasingorganization          = ''"ls_prepitem-PurchasingOrganization
**                                           ) ) ) )
**      ENTITY purchaserequisitionitem
**      CREATE BY \_purchasereqnacctassgmt
**      FIELDS ( CostCenter
**               GLAccount
**               Quantity
**               BaseUnit )
**      WITH VALUE #( ( %cid_ref = 'My%ItemCID_1'
**                      %target  = VALUE #( ( %cid        = 'My%CC_1'
**                                            CostCenter   = key-%param-CostCenter " e.g. 'JMW-COST'
**                                            GLAccount    = '0000400000' ) ) ) )
**      CREATE BY \_purchasereqnitemtext
**      FIELDS ( plainlongtext )
**      WITH VALUE #( ( %cid_ref = 'My%ItemCID_1'
**                      %target  = VALUE #( (
**                                          %cid           = 'My%CCT_1'
**                                          textobjecttype = 'B01'
**                                          language       = 'E'
**                                          plainlongtext  = 'item text created from PAAS API Nick - Workshop prep.'
**                                        ) (
**                                          %cid           = 'My%CCT_2'
**                                          textobjecttype = 'B02'
**                                          language       = 'E'
**                                          plainlongtext  = 'item2 text created from PAAS API Nick'
**                                        ) )
**              )   )
**      REPORTED DATA(ls_pr_reported)
**      MAPPED DATA(ls_pr_mapped)
**      FAILED DATA(ls_pr_failed).
*
*
**      zmm_001_cls=>cv_pr_mapped = ls_pr_mapped.
*
**EML statement for deep create of PR
*        DATA lv_mater TYPE char18.
*        lv_mater = |{ key-%param-ordereditem ALPHA = IN }|.
*
*        AUTHORITY-CHECK OBJECT 'M_BANF_BSA'
*             ID 'ACTVT' FIELD '01'
*             ID 'BSART' FIELD ''.
*
*        AUTHORITY-CHECK OBJECT 'M_BANF_BSA'
*             ID 'ACTVT' FIELD '01'
*             ID 'BSART' FIELD 'NB'.
*
*        AUTHORITY-CHECK OBJECT 'M_BANF_EKG'
*             ID 'ACTVT' FIELD '01'
*             ID 'EKGRP' FIELD '001'.
*
*        AUTHORITY-CHECK OBJECT 'M_BANF_EKG'
*             ID 'ACTVT' FIELD '01'
*             ID 'EKGRP' FIELD ''.
*
*        AUTHORITY-CHECK OBJECT 'M_BANF_EKO'
*             ID 'ACTVT' FIELD '01'
*             ID 'EKORG' FIELD ''.
*        AUTHORITY-CHECK OBJECT 'M_BANF_EKO'
*             ID 'ACTVT' FIELD '01'
*             ID 'EKORG' FIELD '1010'.
*        AUTHORITY-CHECK OBJECT 'M_BANF_WRK'
*             ID 'ACTVT' FIELD '01'
*             ID 'WERKS' FIELD ''.
*        AUTHORITY-CHECK OBJECT 'M_BANF_WRK'
*             ID 'ACTVT' FIELD '01'
*             ID 'WERKS' FIELD '1010'.
*
*        MODIFY ENTITIES OF i_purchaserequisitiontp
*        ENTITY purchaserequisition
*           CREATE FIELDS ( purchaserequisitiontype )
*           WITH VALUE #(  ( %cid                    = 'My%CID_1'
*                            purchaserequisitiontype = 'NB' ) )
*          CREATE BY \_purchaserequisitionitem
*          FIELDS ( plant
*                   purchaserequisitionitemtext
*                   accountassignmentcategory
*                   requestedquantity
*                   baseunit
*                   purchaserequisitionprice
*                   purreqnitemcurrency
*                   material
*                   materialgroup
*                   purchasinggroup
*                   purchasingorganization
**               MultipleAcctAssgmtDistribution
*                       )
*          WITH VALUE #(
*                        (    %cid_ref = 'My%CID_1'
*                             %target = VALUE #(
*                                              (  %cid                        = 'My%ItemCID_1'
*                                                 plant                       = '1010'
*                                                 purchaserequisitionitemtext = 'created from Nick'
*                                                 accountassignmentcategory   = ''
*                                                 requestedquantity           = '10'
*                                                 baseunit                    = 'KG'
*                                                 purchaserequisitionprice    = '10'
*                                                 purreqnitemcurrency         = 'CNY'
*                                                 material                    =  lv_mater"'000000000010100012'
*                                                 materialgroup               = 'Z00101'
*                                                 purchasinggroup             = '001'
*                                                 purchasingorganization      = '1010'
**                                             MultipleAcctAssgmtDistribution = '1'
*                                                 )
*                                              )
*                         )
*                       )
*    ENTITY purchaserequisitionitem
*    CREATE BY \_purchasereqnitemtext
*          FIELDS ( plainlongtext )
*          WITH VALUE #(
*                        (    %cid_ref = 'My%ItemCID_1'
*                             %target = VALUE #(
*                                              (
*                                                %cid           = 'MyTargetCID_2'
*                                                 textobjecttype              = 'B01'
*                                                 language                    = 'ZH'
*                                                 plainlongtext               = 'item text created from PAAS API'
*                                                )
*                                              (
*                                                %cid           = 'MyTargetCID_3'
*                                                 textobjecttype              = 'B02'
*                                                 language                    = 'ZH'
*                                                 plainlongtext               = 'item2 text created from PAAS API'
*                                                )
*                                              )
*                         )
*                       )
*        REPORTED DATA(ls_pr_reported)
*                 MAPPED DATA(ls_pr_mapped)
*                 FAILED DATA(ls_pr_failed).
*        zmm_001_cls=>cv_pr_mapped = ls_pr_mapped.
*
*      CATCH cx_root INTO DATA(exception).
*        " Handle exception
*    ENDTRY.
*
*  ENDMETHOD.
*
*
*  METHOD update_inforecord.
*    SELECT SINGLE * FROM i_purchasinginforecordtp  WHERE purchasinginforecord = '5500000219' INTO @DATA(ls_data).
*
** Update an existing info record
*    MODIFY ENTITIES OF i_purchasinginforecordtp
*           ENTITY purchasinginforecord
*           UPDATE SET FIELDS WITH
*           VALUE #( ( %key-purchasinginforecord = '5500000219'
*                       supplier                 = ls_data-supplier
*                       materialgroup            = ls_data-materialgroup
*                       suppliermaterialgroup    = ls_data-suppliermaterialgroup
*                       nodaysreminder1          = '12'
*                       purchasinginforecorddesc = 'noDays remainder updated'
*                  ) )
*             FAILED   DATA(ls_failed_update)
*             REPORTED DATA(ls_reported_update)
*             MAPPED   DATA(ls_mapped_update).
*
*  ENDMETHOD.
*
*  METHOD calculate_order_id.
*
*    DATA:
*      online_shops TYPE TABLE FOR UPDATE znick_i_online_shop,
*      online_shop  TYPE STRUCTURE FOR UPDATE znick_i_online_shop.
*
*    READ ENTITIES OF znick_i_online_shop IN LOCAL MODE
*       ENTITY online_shop
*        ALL FIELDS
*          WITH CORRESPONDING #( keys )
*          RESULT DATA(lt_online_shop_result)
*      FAILED    DATA(lt_failed)
*      REPORTED  DATA(lt_reported).
*    DATA(today) = cl_abap_context_info=>get_system_date( ).
*
*    " get the product groups for the products
*    READ ENTITIES OF i_producttp_2
*    ENTITY product
*    ALL FIELDS WITH VALUE #( ( product = lt_online_shop_result[ 1 ]-ordereditem ) )
*    RESULT DATA(product_data)
*    FAILED DATA(failed_pr_data)
*    REPORTED DATA(reported_pr_data).
*
*    LOOP AT lt_online_shop_result INTO DATA(online_shop_read).
*      online_shop               = CORRESPONDING #( online_shop_read ).
*      IF online_shop-order_id IS INITIAL.
*        TRY.
*            CALL METHOD cl_numberrange_runtime=>number_get
*              EXPORTING
*                nr_range_nr = '01'
*                object      = 'ZNICK_NR01'
*              IMPORTING
*                number      = DATA(order_id)
*                returncode  = DATA(rcode).
*          CATCH cx_nr_object_not_found.
*          CATCH cx_number_ranges.
*        ENDTRY.
*        online_shop-order_id = CONV int4( order_id ).
*        online_shop-creationdate  = today.
*        IF online_shop-deliverydate IS INITIAL.
*          online_shop-deliverydate  = today + 10.
*        ENDIF.
*
*        APPEND online_shop TO online_shops.
*      ENDIF.
*    ENDLOOP.
*    MODIFY ENTITIES OF znick_i_online_shop IN LOCAL MODE
*    ENTITY znick_i_online_shop UPDATE SET FIELDS WITH online_shops
*    MAPPED   DATA(ls_mapped_modify)
*    FAILED   DATA(lt_failed_modify)
*    REPORTED DATA(lt_reported_modify).
*
*    DATA: lt_create_pr_imp TYPE TABLE FOR ACTION IMPORT  znick_i_online_shop~create_pr,
*          ls_create_pr_imp LIKE LINE OF lt_create_pr_imp.
*
*
*    LOOP AT online_shops INTO DATA(online_shop_result).
*      ls_create_pr_imp-order_uuid = online_shop_result-order_uuid.
*      ls_create_pr_imp-%param = CORRESPONDING #( online_shop_result ).
*      APPEND ls_create_pr_imp TO lt_create_pr_imp.
*    ENDLOOP.
*
*    " if a new online order is created, trigger a new purchase requisition
*    IF lt_failed_modify IS INITIAL.
*      MODIFY ENTITIES OF znick_i_online_shop IN LOCAL MODE
*      ENTITY online_shop EXECUTE create_pr FROM CORRESPONDING #( lt_create_pr_imp )
*      FAILED DATA(lt_pr_failed)
*      REPORTED DATA(lt_pr_reported).
*    ENDIF.
*
*  ENDMETHOD.
*
*ENDCLASS.
